#include "string.h"

#include "SDL.h"
#include "SDL_mixer.h"
#include "SDL_ttf.h"

#include "MOG2_auxiliar.h"

#include "samples.h"

#ifdef KITSCHY_DEBUG_MEMORY 
#include "debug_memorymanager.h"
#endif

SAMPLE::SAMPLE()
{
	name=0;
	fname=0;
	sample=0;
} /* SAMPLE::SAMPLE */ 


SAMPLE::SAMPLE(char *n,char *file)
{
	name=new char[strlen(n)+1];
	strcpy(name,n);

	fname=new char[strlen(file)+1];
	strcpy(fname,file);

	sample=0;
	sample=Mix_LoadWAV(file);
	
} /* SAMPLE::SAMPLE */ 


SAMPLE::~SAMPLE()
{
	delete []name;
	name=0;

	delete []fname;
	fname=0;

	Mix_FreeChunk(sample);
} /* SAMPLE::~SAMPLE */ 


bool SAMPLE::save(FILE *fp)
{
	char *s1;
	encode_string(name,&s1);
	fprintf(fp,"%s\n",s1);
	delete []s1;
	encode_string(fname,&s1);
	fprintf(fp,"%s\n",s1);
	delete []s1;
	return true;
} /* SAMPLE::save */ 


bool SAMPLE::load(FILE *fp)
{
	delete []name;
	if (!load_string(fp,&name)) return false;
	delete []fname;
	if (!load_string(fp,&fname)) return false;

	if (sample!=0) Mix_FreeChunk(sample);
	sample=0;
	sample=Mix_LoadWAV(fname);
	return true;
} /* SAMPLE::load */ 


void SAMPLE::change_name(char *n)
{
	delete []name;
	name=new char[strlen(n)+1];
	strcpy(name,n);
} /* SAMPLE::change_name */ 


bool SAMPLE::cmp(char *n)
{
	if (strcmp(name,n)==0) return true;
	return false;
} /* SAMPLE::cmp */ 

